SystemOrganization addCategory: #'MonticelloFileDirectory-Base'!
SystemOrganization addCategory: #'MonticelloFileDirectory-Test'!

TestCase subclass: #McFdTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

McFdTestCase subclass: #McFdFilesystemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 17:21'!
testCreateDirectory
	| dir creator aPackage |
	creator := McFdCreator new.
	dir := FileDirectory default.
	aPackage := MCPackage named: self packageName .
	
	[creator createDirectoryForPackage: aPackage at: dir.
	self assert: (dir directoryExists: aPackage name)] 
			ensure: [dir deleteDirectory: aPackage name]! !

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 17:45'!
testCreateSubDirectory
	| dir creator aPackage |
	creator := McFdCreator new.
	dir := FileDirectory default.
	aPackage := MCPackage named: self packageName .
	
	[creator createDirectoryForPackage: aPackage at: dir.
	self assert: (dir directoryExists: aPackage name).
	creator createSubDirectoryForClassCategoriesForPackage: aPackage at: (dir directoryNamed: aPackage name) .
	self assert: (dir directoryExists: self  packageName , FileDirectory slash , self subPackageName)
	] ensure: [(dir directoryNamed: aPackage name) recursiveDelete]! !

!McFdFilesystemTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 17:07'!
testExtractCategoryString
	| creator aString resultString |
	aString := 'Spaet-Abends'.
	creator := McFdCreator new.
	resultString := creator extractCategoryStringFrom: aString.
	self assert: 'Abends' = resultString.
	! !

McFdTestCase subclass: #McFdPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Test'!

!McFdPackageTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 13:16'!
testCreateMethod
	(Smalltalk at: #McFdFooBar) methodDictionary at: #m1 ifAbsent: [self fail] 
	! !

!McFdPackageTest methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 13:16'!
testCreatePackage
	Smalltalk at: #McFdFooBar ifAbsent: [self fail].
	
	! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 15:17'!
classCategoryName
	^ self packageName , '-' , self subPackageName! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 15:07'!
packageName
	^ 'McFdFooBar'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 14:15'!
setUp
	Object 
		subclass: #McFdFooBar
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self classCategoryName.
	(Smalltalk at: #McFdFooBar) compile: 'm1 ^ 0'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 15:17'!
subPackageName
	^ 'Base'! !

!McFdTestCase methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 14:20'!
tearDown
	(Smalltalk at: #McFdFooBar) removeFromSystemUnlogged.
	
	Smalltalk organization removeCategory: self classCategoryName asSymbol! !

MCWriter subclass: #MCFileDirectoryWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Base'!

!MCFileDirectoryWriter methodsFor: 'as yet unclassified' stamp: 'MU 11/21/2007 12:33'!
writeVersion: aVersion! !

Object subclass: #McFdCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Base'!

!McFdCreator methodsFor: 'creation' stamp: 'pe 11/22/2007 14:53'!
createAllForPackage: aPackage at: aDirectory
"calls createDirectoryForPackage: at: and createSubDirectoryForClassCategoriesForPackage: at:"

	| dirString |
	self createDirectoryForPackage: aPackage at: aDirectory.
	dirString := aDirectory fullName, FileDirectory slash asSymbol, aPackage name.
	dirString := FileDirectory on: dirString.
	self createSubDirectoryForClassCategoriesForPackage: aPackage at: dirString.! !

!McFdCreator methodsFor: 'creation' stamp: 'MU 11/21/2007 14:48'!
createDirectoryForPackage: aPackage at: aDirectory 
	aDirectory createDirectory: aPackage name! !

!McFdCreator methodsFor: 'creation' stamp: 'MU 11/21/2007 17:46'!
createSubDirectoryForClassCategoriesForPackage: aPackage at: aDirectory
	
	aPackage packageInfo systemCategories do: [:each | 
		aDirectory createDirectory: (self extractCategoryStringFrom: each asString) ]! !

!McFdCreator methodsFor: 'creation' stamp: 'MU 11/21/2007 17:15'!
extractCategoryStringFrom: aString 
	^ (aString subStrings: '-') second.
! !

MCVersion subclass: #MCFileVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileDirectory-Base'!

!MCFileVersion class methodsFor: 'converting' stamp: 'pe 11/22/2007 11:46'!
fromVersion: aVersion
	^(self new)
		package: aVersion package;
		info: aVersion info;
		snapshot: aVersion snapshot;
		dependencies: aVersion dependencies.! !

!MCFileVersion class methodsFor: 'accessing' stamp: 'pe 11/22/2007 11:53'!
writerClass
	^MCFileDirectoryWriter! !

!MCFileVersion methodsFor: 'private-converting' stamp: 'pe 11/22/2007 11:51'!
dependencies: aDependencies
	dependencies := aDependencies! !

!MCFileVersion methodsFor: 'private-converting' stamp: 'pe 11/22/2007 11:51'!
info: aInfo
	info := aInfo! !

!MCFileVersion methodsFor: 'private-converting' stamp: 'pe 11/22/2007 11:52'!
package: aPackage
	package := aPackage! !

!MCFileVersion methodsFor: 'private-converting' stamp: 'pe 11/22/2007 11:52'!
snapshot: aSnapshot
	snapshot := aSnapshot! !
